VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CoolMenu sample from BlackBeltVB.com"
   ClientHeight    =   3465
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   7875
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3465
   ScaleWidth      =   7875
   Begin VB.TextBox Text1 
      Height          =   1095
      Left            =   180
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   2280
      Width           =   7515
   End
   Begin VB.Timer tmrMenu 
      Interval        =   100
      Left            =   3780
      Top             =   2100
   End
   Begin VB.PictureBox pTools 
      Align           =   1  'Align Top
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   645
      Left            =   0
      Picture         =   "coolmenu.frx":0000
      ScaleHeight     =   645
      ScaleWidth      =   7875
      TabIndex        =   0
      Top             =   0
      Width           =   7875
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"coolmenu.frx":5C46
      Height          =   1335
      Left            =   180
      TabIndex        =   1
      Top             =   780
      Width           =   7575
   End
   Begin VB.Menu mnuMain 
      Caption         =   "Back"
      Index           =   1
      Visible         =   0   'False
      Begin VB.Menu mnuBack 
         Caption         =   "Back"
      End
   End
   Begin VB.Menu mnuMain 
      Caption         =   "Forward"
      Index           =   2
      Visible         =   0   'False
      Begin VB.Menu mnuForward 
         Caption         =   "Forward"
      End
   End
   Begin VB.Menu mnuMain 
      Caption         =   "Stop"
      Index           =   3
      Visible         =   0   'False
      Begin VB.Menu mnuStop 
         Caption         =   "Stop"
      End
   End
   Begin VB.Menu mnuMain 
      Caption         =   "Refresh"
      Index           =   4
      Visible         =   0   'False
      Begin VB.Menu mnuRefresh 
         Caption         =   "Refresh"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' CoolMenu sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 2000 by Matt Hart
'
' This software is FREEWARE. You may use it as you see fit for
' your own projects but you may not re-sell the original or the
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/free/coolmenu.htm"
'
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' Shows how to implement "CoolMenu" toolbars without the
' need for any special controls or libraries.


Const lToolWidth = 750
Const lToolHeight = 600
Const lToolLeft = 215
Const lNumTools = 4

Dim lCurTool As Long, tPPX As Long, tPPY As Long

Private Sub Form_Load()
    tPPX = Screen.TwipsPerPixelX
    tPPY = Screen.TwipsPerPixelY
End Sub

Private Sub pTools_Click()
    MsgBox "You clicked tool number " & lCurTool
    lCurTool = 0
End Sub

Private Sub pTools_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim lNextTool As Long
    If x >= lToolLeft Then
        lNextTool = ((x - lToolLeft) \ lToolWidth) + 1
    End If
    If lNextTool <> lCurTool Then
        lCurTool = lNextTool
        If lNextTool > 0 And lNextTool <= lNumTools Then
            tmrMenu.Enabled = True
            hHook = SetWindowsHookEx(WH_CALLWNDPROC, AddressOf AppHook, App.hInstance, App.ThreadID)
            PopupMenu mnuMain(lNextTool), 0, lToolLeft + (lNextTool - 1) * lToolWidth, pTools.Height
            lCurTool = 0
            If hHook Then UnhookWindowsHookEx hHook
            tmrMenu.Enabled = False
        End If
    End If
End Sub

Private Sub tmrMenu_Timer()
    Static hMenu As Long, rMenu As RECT
    Dim Pt As POINTAPI, cPt As Currency, lPtInRect As Long
    If hMenu <> hwndMenu Then
        GetWindowRect hMenu, rMenu
    End If
    GetCursorPos Pt
    CopyMemory cPt, Pt, 8
    lPtInRect = PtInRect(rMenu, ByVal cPt)
    If lPtInRect = 0 Then
        ScreenToClient pTools.hwnd, Pt
        Dim x As Single, lNextTool As Long
        x = Pt.x * Screen.TwipsPerPixelX
        If x >= lToolLeft Then
            lNextTool = ((x - lToolLeft) \ lToolWidth) + 1
        End If
        If lNextTool <> lCurTool Then
            If lNextTool > 0 And lNextTool <= lNumTools Then
                tmrMenu.Enabled = False
                SendKeys "{ESC}"
                
                hHook = SetWindowsHookEx(WH_CALLWNDPROC, AddressOf AppHook, App.hInstance, App.ThreadID)
                PopupMenu mnuMain(lNextTool), 0, lToolLeft + (lNextTool - 1) * lToolWidth, pTools.Height
                lCurTool = 0
                If hHook Then UnhookWindowsHookEx hHook
                tmrMenu.Enabled = False
            Else
                SendKeys "{ESC}"
                lCurTool = 0
            End If
        End If
    End If
End Sub
